// Generated by CoffeeScript 1.3.3
(function() {
  var GamePlatform,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  GamePlatform = (function() {

    function GamePlatform(stage, width, height, contentManager) {
      var background, ship, shipAnimation, shipSpriteSheet, sq, sqAnimation, sqSpriteSheet, text,
        _this = this;
      this.stage = stage;
      this.tick = __bind(this.tick, this);

      background = new createjs.Bitmap(contentManager.background);
      background.setTransform(0, 0, width / 400.0, height / 300.0);
      this.stage.addChild(background);
      text = new createjs.Text("Click on the characters!", "bold 24px Meiryo", "#000");
      text.x = (width / 2) - (text.getMeasuredWidth() / 2);
      text.y = 10;
      this.stage.addChild(text);
      shipSpriteSheet = new createjs.SpriteSheet({
        images: [contentManager.ship],
        frames: {
          width: 100,
          height: 100,
          regX: 50,
          regY: 50
        },
        animations: {
          move: {
            frames: [0, 1, 2, 3, 4, 5],
            frequency: 10
          }
        }
      });
      shipAnimation = new createjs.BitmapAnimation(shipSpriteSheet);
      shipAnimation.x = shipAnimation.y = 100;
      ship = new createjs.Bitmap(createjs.SpriteSheetUtils.extractFrame(shipSpriteSheet, 0));
      ship.regX = ship.regY = 50;
      ship.x = ship.y = 100;
      ship.onClick = function() {
        shipAnimation.rotation = 90;
        _this.stage.addChild(shipAnimation);
        shipAnimation.gotoAndPlay("move");
        _this.stage.removeChild(ship);
        return createjs.Tween.get(shipAnimation).to({
          x: width + 100,
          scaleX: 2,
          scaleY: 2
        }, 1000, createjs.Ease.cubicIn).to({
          rotation: 270
        }).to({
          x: 100,
          scaleX: 1,
          scaleY: 1
        }, 1000, createjs.Ease.cubicOut).to({
          rotation: 0
        }, 500).wait(500).call(function() {
          _this.stage.addChild(ship);
          _this.stage.removeChild(shipAnimation);
          return shipAnimation.stop();
        });
      };
      this.stage.addChild(ship);
      sqSpriteSheet = new createjs.SpriteSheet({
        images: [contentManager.square],
        frames: {
          width: 100,
          height: 130,
          regX: 50,
          regY: 65
        },
        animations: {
          walk: {
            frames: [0, 1, 2, 3, 4],
            frequency: 20
          }
        }
      });
      sqAnimation = new createjs.BitmapAnimation(sqSpriteSheet);
      sqAnimation.x = 100;
      sqAnimation.y = 250;
      sq = new createjs.Bitmap(createjs.SpriteSheetUtils.extractFrame(sqSpriteSheet, 0));
      sq.regX = 50;
      sq.regY = 65;
      sq.x = 100;
      sq.y = 250;
      sq.onClick = function() {
        _this.stage.addChild(sqAnimation);
        sqAnimation.gotoAndPlay("walk");
        _this.stage.removeChild(sq);
        return createjs.Tween.get(sqAnimation).to({
          x: width + 100
        }, 1000, createjs.Ease.quadInOut).to({
          scaleX: -1
        }).to({
          x: 100
        }, 1000, createjs.Ease.bounceOut).to({
          scaleX: 1
        }).wait(500).call(function() {
          _this.stage.addChild(sq);
          _this.stage.removeChild(sqAnimation);
          return sqAnimation.stop();
        });
      };
      this.stage.addChild(sq);
      this.fps = new createjs.Text("0 fps", "bold 14px Arial", "#000");
      this.fps.x = this.fps.y = 10;
      this.stage.addChild(this.fps);
    }

    GamePlatform.prototype.startGame = function() {
      createjs.Ticker.userRAF = true;
      createjs.Ticker.setFPS(60);
      return createjs.Ticker.addListener(this);
    };

    GamePlatform.prototype.tick = function() {
      this.fps.text = (Math.round(createjs.Ticker.getMeasuredFPS())) + " fps";
      return this.stage.update();
    };

    return GamePlatform;

  })();

  window.GamePlatform = GamePlatform;

}).call(this);
